<?php

/**
 * inf_relacion_pagos actions.
 *
 * @package    controlComisiones
 * @subpackage inf_relacion_pagos
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_relacion_pagosActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tab0.fecha_pago, tab0.no_pago ';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $id_anhos = $request['id_anhos'];
            $id_proyecto = $request['id_proyecto'];
            $id_firma = $request['id_firma'];
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];


            /*
             * Variables opcionales
             */
            $whereNoPago = "";
            if (isset($request['no_pago'])) {
                $whereNoPago = " AND tab0.no_pago = " . $request['no_pago'];
            }
            $whereNoCaja = "";
            if (isset($request['no_caja'])) {
                $whereNoCaja = " AND tab0.no_caja = " . $request['no_caja'];
            }
            $whereNoComision = "";
            if (isset($request['no_comision'])) {
                $whereNoComision = " AND tab0.no_comision = " . $request['no_comision'];
            }
            $whereNoResolucion = "";
            if (isset($request['no_resolucion'])) {
                $whereNoResolucion = " AND tab0.no_resolucion = " . $request['no_resolucion'];
            }


            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            
            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

select tab0.* from(
    select 
    tab0.id_anhos,
    tab0.no_pago,
    tab0.fecha_pago as fecha_pago,
    tab9.no_comision as no_comision,
    tab9.fecha_solicitud as fecha_solicitud,
    tab6.descripcion as fci,
    tab2.no_resolucion as no_resolucion, 
    tab2.fecha_resolucion as fecha_resol,
    tab4.nombre as beneficiario,
    tab4.num_doc as identif, 
    tab5.codigo_co as co,
    tab7.descripcion as tipo_cuenta,
    tab4.numero_cuenta,
    tab8.codigo as cod_banco,
    tab8.descripcion as banco,
    tab0.valor_neto as egreso,
    tab1.no_caja
    
    from com_pago_egreso tab0
    join com_cuenta tab1 on tab1.id_cuenta = tab0.id_cuenta
    join com_resolucion tab2 on tab2.id_resolucion = tab1.id_resolucion
    join com_comisionado tab3 on tab3.id_comision = tab2.id_comision and tab3.id_tercero = tab1.id_tercero
    join com_tercero tab4 on tab4.id_tercero = tab3.id_tercero
    join tipo_documento tab5 on tab5.id_tipo_doc = tab4.id_tipo_doc
    join com_tipo_comisionado tab6 on tab6.tipter = tab4.tipter
    left join ts_tc tab7 on tab7.id = tab4.tipo_cuenta
    left join ts_bn tab8 on tab8.id_bn = tab4.banco
    join com_comision tab9 on tab9.id_comision = tab2.id_comision 

    where
    tab9.id_proyecto = $id_proyecto
    and tab0.fecha_pago between to_date( '$fecha_ini' , 'yyyy-mm-dd' ) and to_date( '$fecha_fin' , 'yyyy-mm-dd' )
                        
)tab0

where 
tab0.id_anhos = $id_anhos 
$whereNoPago $whereNoCaja
$whereNoComision $whereNoResolucion    

)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select tab0.* from(
    select 
    tab0.id_anhos,
    tab0.no_pago,
    tab0.fecha_pago as fecha_pago,
    tab9.no_comision as no_comision,
    tab9.fecha_solicitud as fecha_solicitud,
    tab6.descripcion as fci,
    tab2.no_resolucion as no_resolucion, 
    tab2.fecha_resolucion as fecha_resol,
    tab4.nombre as beneficiario,
    tab4.num_doc as identif, 
    tab5.codigo_co as co,
    tab7.descripcion as tipo_cuenta,
    tab4.numero_cuenta,
    tab8.codigo as cod_banco,
    tab8.descripcion as banco,
    tab0.valor_neto as egreso,
    tab1.no_caja
    
    from com_pago_egreso tab0
    join com_cuenta tab1 on tab1.id_cuenta = tab0.id_cuenta
    join com_resolucion tab2 on tab2.id_resolucion = tab1.id_resolucion
    join com_comisionado tab3 on tab3.id_comision = tab2.id_comision and tab3.id_tercero = tab1.id_tercero
    join com_tercero tab4 on tab4.id_tercero = tab3.id_tercero
    join tipo_documento tab5 on tab5.id_tipo_doc = tab4.id_tipo_doc
    join com_tipo_comisionado tab6 on tab6.tipter = tab4.tipter
    left join ts_tc tab7 on tab7.id = tab4.tipo_cuenta
    left join ts_bn tab8 on tab8.id_bn = tab4.banco
    join com_comision tab9 on tab9.id_comision = tab2.id_comision 

    where
    tab9.id_proyecto = $id_proyecto
    and tab0.fecha_pago between to_date( '$fecha_ini' , 'yyyy-mm-dd' ) and to_date( '$fecha_fin' , 'yyyy-mm-dd' )
        
)tab0

where 
tab0.id_anhos = $id_anhos 
$whereNoPago $whereNoCaja
$whereNoComision $whereNoResolucion

$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_estado_cm] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
